#include <stdio.h>
#include <stdlib.h>
#include <limits.h>

void sort(int n,signed long long int a[]);
void swap(int *a,int *b);

int main()
{
    int t,n,m,x=INT_MAX;
    signed long long int temp;
    scanf("%d",&t);
    int b[t];

    for(int i=0;i<t;i++)
    {
        b[i] = 1;
        scanf("%d%d",&n,&m);
        signed long long int a[n];

        for(int j=0;j<n;j++)
        {
            scanf("%lld",&a[j]);
        }
        sort(n,a);

        for(int j=n;j>1;j--)
        {
            a[j-1]=a[j-1]-a[j-2];
        }

        for(int j=0;j<n;j++)
        {
            if(a[j]<x && a[j] != 0 && a[j] != 1)
            {
                x=a[j];
            }
        }

        for(int j=1;j<n;j++)
        {
            if(a[j]%x != 0)
            {
                b[i]=0;
            }
        }

         for(int j=0;j<m;j++)
        {
            scanf("%lld",&temp);
            if(temp%x==0 && b[i]==1)
            {
                b[i]=0;
            }
        }
    }
    for(int i=0;i<m;i++)
    {
        printf("%d\n",b[i]);
    }
    return 0;
}

void sort(int n, signed long long int a[])
{
    for(int j=0; j<n-1; j++)
    {
        for(int i=0;i<n-1-j;i++)
        {
            if(a[i]>a[i+1])
                swap(&a[i], &a[i+1]);
        }
    }
}

void swap(int *a,int *b)
{
    int temp;
    temp=*a;
    *a=*b;
    *b=temp;
}